'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _devui = require('devui');

var _theme = require('devui/lib/utils/theme');

var _actions = require('../../actions');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Themes = (_temp = _class = function (_Component) {
  _inherits(Themes, _Component);

  function Themes() {
    _classCallCheck(this, Themes);

    return _possibleConstructorReturn(this, (Themes.__proto__ || Object.getPrototypeOf(Themes)).apply(this, arguments));
  }

  _createClass(Themes, [{
    key: 'render',
    value: function render() {
      var theme = this.props.theme;
      var formData = {
        theme: theme.theme,
        scheme: theme.scheme,
        dark: !theme.light
      };

      return _react2.default.createElement(
        _devui.Container,
        null,
        _react2.default.createElement(_devui.Form, {
          schema: {
            type: 'object',
            properties: {
              theme: {
                type: 'string',
                enum: (0, _theme.listThemes)()
              },
              scheme: {
                title: 'color scheme',
                type: 'string',
                enum: (0, _theme.listSchemes)()
              },
              dark: {
                type: 'boolean'
              }
            }
          },
          formData: formData,
          noSubmit: true,
          onChange: this.props.changeTheme
        })
      );
    }
  }]);

  return Themes;
}(_react.Component), _class.propTypes = {
  changeTheme: _react.PropTypes.func.isRequired,
  theme: _react.PropTypes.object.isRequired
}, _temp);


function mapStateToProps(state) {
  return {
    theme: state.theme
  };
}

function mapDispatchToProps(dispatch) {
  return {
    changeTheme: (0, _redux.bindActionCreators)(_actions.changeTheme, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Themes);
module.exports = exports['default'];