'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reduxDevtoolsInstrument = require('redux-devtools-instrument');

var _devui = require('devui');

var _RecordButton = require('./buttons/RecordButton');

var _RecordButton2 = _interopRequireDefault(_RecordButton);

var _PersistButton = require('./buttons/PersistButton');

var _PersistButton2 = _interopRequireDefault(_PersistButton);

var _LockButton = require('./buttons/LockButton');

var _LockButton2 = _interopRequireDefault(_LockButton);

var _InstanceSelector = require('./InstanceSelector');

var _InstanceSelector2 = _interopRequireDefault(_InstanceSelector);

var _SyncButton = require('./buttons/SyncButton');

var _SyncButton2 = _interopRequireDefault(_SyncButton);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var reset = _reduxDevtoolsInstrument.ActionCreators.reset,
    rollback = _reduxDevtoolsInstrument.ActionCreators.rollback,
    commit = _reduxDevtoolsInstrument.ActionCreators.commit,
    sweep = _reduxDevtoolsInstrument.ActionCreators.sweep;
var TopButtons = (_temp2 = _class = function (_Component) {
  _inherits(TopButtons, _Component);

  function TopButtons() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, TopButtons);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = TopButtons.__proto__ || Object.getPrototypeOf(TopButtons)).call.apply(_ref, [this].concat(args))), _this), _this.handleRollback = function () {
      _this.props.dispatch(rollback());
    }, _this.handleSweep = function () {
      _this.props.dispatch(sweep());
    }, _this.handleCommit = function () {
      _this.props.dispatch(commit());
    }, _this.handleReset = function () {
      _this.props.dispatch(reset());
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(TopButtons, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps) {
      return nextProps.options !== this.props.options || nextProps.liftedState !== this.props.liftedState;
    }
  }, {
    key: 'render',
    value: function render() {
      var options = this.props.options;
      var features = options.features;
      var _props$liftedState = this.props.liftedState,
          computedStates = _props$liftedState.computedStates,
          skippedActionIds = _props$liftedState.skippedActionIds,
          isPaused = _props$liftedState.isPaused,
          isLocked = _props$liftedState.isLocked;

      var noStates = computedStates.length < 2;

      return _react2.default.createElement(
        _devui.Toolbar,
        { borderPosition: 'bottom' },
        features.pause && _react2.default.createElement(_RecordButton2.default, { paused: isPaused }),
        features.persist && _react2.default.createElement(_PersistButton2.default, null),
        features.lock && _react2.default.createElement(_LockButton2.default, {
          locked: isLocked,
          disabled: options.lib !== 'redux'
        }),
        _react2.default.createElement(_devui.Divider, null),
        _react2.default.createElement(
          _devui.Button,
          {
            title: 'Reset to the state you created the store with',
            tooltipPosition: 'bottom',
            onClick: this.handleReset
          },
          'Reset'
        ),
        _react2.default.createElement(
          _devui.Button,
          {
            title: 'Roll back to the last committed state',
            tooltipPosition: 'bottom',
            onClick: this.handleRollback,
            disabled: noStates
          },
          'Revert'
        ),
        _react2.default.createElement(
          _devui.Button,
          {
            title: 'Remove all currently disabled actions from the log',
            tooltipPosition: 'bottom',
            onClick: this.handleSweep,
            disabled: skippedActionIds.length === 0
          },
          'Sweep'
        ),
        _react2.default.createElement(
          _devui.Button,
          {
            title: 'Remove all actions from the log,\\a and make the current state your initial state',
            tooltipPosition: 'bottom',
            onClick: this.handleCommit,
            disabled: noStates
          },
          'Commit'
        ),
        _react2.default.createElement(_devui.Divider, null),
        _react2.default.createElement(_InstanceSelector2.default, null),
        features.sync && _react2.default.createElement(_SyncButton2.default, null)
      );
    }
  }]);

  return TopButtons;
}(_react.Component), _class.propTypes = {
  // shouldSync: PropTypes.bool,
  liftedState: _react.PropTypes.object.isRequired,
  dispatch: _react.PropTypes.func.isRequired,
  options: _react.PropTypes.object.isRequired
}, _temp2);
exports.default = TopButtons;
module.exports = exports['default'];