'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactRedux = require('react-redux');

var _redux = require('redux');

var _devui = require('devui');

var _actions = require('../actions');

var _Header = require('../components/Header');

var _Header2 = _interopRequireDefault(_Header);

var _Actions = require('../containers/Actions');

var _Actions2 = _interopRequireDefault(_Actions);

var _Settings = require('../components/Settings');

var _Settings2 = _interopRequireDefault(_Settings);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var App = function (_Component) {
  _inherits(App, _Component);

  function App() {
    _classCallCheck(this, App);

    return _possibleConstructorReturn(this, (App.__proto__ || Object.getPrototypeOf(App)).apply(this, arguments));
  }

  _createClass(App, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          section = _props.section,
          theme = _props.theme,
          notification = _props.notification;

      var body = void 0;
      switch (section) {
        case 'Settings':
          body = _react2.default.createElement(_Settings2.default, null);break;
        default:
          body = _react2.default.createElement(_Actions2.default, null);
      }

      return _react2.default.createElement(
        _devui.Container,
        { themeData: theme },
        _react2.default.createElement(_Header2.default, { section: section }),
        body,
        notification && _react2.default.createElement(
          _devui.Notification,
          { type: notification.type, onClose: this.props.clearNotification },
          notification.message
        )
      );
    }
  }]);

  return App;
}(_react.Component);

App.propTypes = {
  section: _react.PropTypes.string.isRequired,
  theme: _react.PropTypes.object.isRequired,
  notification: _react.PropTypes.shape({
    message: _react.PropTypes.string,
    type: _react.PropTypes.string
  }),
  clearNotification: _react.PropTypes.func
};

function mapStateToProps(state) {
  return {
    section: state.section,
    theme: state.theme,
    notification: state.notification
  };
}

function mapDispatchToProps(dispatch) {
  return {
    clearNotification: (0, _redux.bindActionCreators)(_actions.clearNotification, dispatch)
  };
}

exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(App);
module.exports = exports['default'];